﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinScrollBar

Imports System.Collections.Generic
Imports System.ComponentModel

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        UltraComboEditor1.CreationFilter = New CreationUIElement(ScrollWidth, ButtonHeight)
    End Sub
End Class

Public Class CreationUIElement : Implements IUIElementCreationFilter

    Private _scrollBarWidth As Integer
    Private _buttonHeight As Integer
    Public Sub New(ByVal scrollBarWidth As Integer, ByVal buttonHeight As Integer)
        _scrollBarWidth = scrollBarWidth
        _buttonHeight = buttonHeight
    End Sub



    Public Sub AfterCreateChildElements(ByVal parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements


        If TypeOf parent Is ValueListDropDownUIElement Then
            For Each element As UIElement In parent.ChildElements
                If TypeOf element Is ValueListItemContainerUIElement Then
                    element.Rect = New Rectangle(element.Rect.X, element.Rect.Y, parent.Rect.Width - Me._scrollBarWidth, element.Rect.Height)
                ElseIf TypeOf element Is ScrollBarUIElement Then
                    element.Rect = New Rectangle(parent.Rect.Right - Me._scrollBarWidth, element.Rect.Y, Me._scrollBarWidth, element.Rect.Height)
                End If
            Next
        End If

        If TypeOf parent Is ScrollBarUIElement Then
            For Each element As UIElement In parent.ChildElements
                If TypeOf element Is ScrollButtonUIElement Then
                    Dim scrollButtonUIElement As ScrollButtonUIElement = DirectCast(element, ScrollButtonUIElement)
                    If scrollButtonUIElement.ScrollButtonType = ScrollButton.Up Then
                        element.Rect = New Rectangle(element.Rect.X, element.Rect.Y, element.Rect.Width, Me._buttonHeight)
                    ElseIf scrollButtonUIElement.ScrollButtonType = ScrollButton.Down Then
                        element.Rect = New Rectangle(element.Rect.X, parent.Rect.Bottom - Me._buttonHeight, element.Rect.Width, Me._buttonHeight)
                    End If
                ElseIf TypeOf element Is ScrollTrackUIElement Then
                    element.Rect = New Rectangle(element.Rect.X, parent.Rect.Top + Me._buttonHeight, element.Rect.Width, parent.Rect.Height - (Me._buttonHeight * 2))
                End If
            Next
        End If
    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function
End Class
